"use strict";

var _react = _interopRequireDefault(require("react"));

var _getDisplayName = _interopRequireWildcard(require("../getDisplayName"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

describe('utils/getDisplayName.js', function () {
  describe('getDisplayName', function () {
    it('gets the display name of a React component', function () {
      var SomeComponent =
      /*#__PURE__*/
      function (_React$Component) {
        _inherits(SomeComponent, _React$Component);

        function SomeComponent() {
          _classCallCheck(this, SomeComponent);

          return _possibleConstructorReturn(this, _getPrototypeOf(SomeComponent).apply(this, arguments));
        }

        _createClass(SomeComponent, [{
          key: "render",
          value: function render() {
            return _react.default.createElement("div", null);
          }
        }]);

        return SomeComponent;
      }(_react.default.Component);

      var SomeOtherComponent =
      /*#__PURE__*/
      function (_React$Component2) {
        _inherits(SomeOtherComponent, _React$Component2);

        function SomeOtherComponent() {
          _classCallCheck(this, SomeOtherComponent);

          return _possibleConstructorReturn(this, _getPrototypeOf(SomeOtherComponent).apply(this, arguments));
        }

        _createClass(SomeOtherComponent, [{
          key: "render",
          value: function render() {
            return _react.default.createElement("div", null);
          }
        }]);

        return SomeOtherComponent;
      }(_react.default.Component);

      _defineProperty(SomeOtherComponent, "displayName", 'CustomDisplayName');

      function YetAnotherComponent() {
        return _react.default.createElement("div", null);
      }

      var AndAnotherComponent = function AndAnotherComponent() {
        return _react.default.createElement("div", null);
      };

      expect((0, _getDisplayName.default)(SomeComponent)).toEqual('SomeComponent');
      expect((0, _getDisplayName.default)(SomeOtherComponent)).toEqual('CustomDisplayName');
      expect((0, _getDisplayName.default)(YetAnotherComponent)).toEqual('YetAnotherComponent');
      expect((0, _getDisplayName.default)(AndAnotherComponent)).toEqual('AndAnotherComponent');
      expect((0, _getDisplayName.default)(function () {
        return _react.default.createElement("div", null);
      })).toEqual('Component');
      expect((0, _getDisplayName.default)('div')).toEqual('div');
      expect((0, _getDisplayName.default)()).toEqual(undefined);
    });
  });
  describe('getFunctionName', function () {
    it('gets the name of a function', function () {
      function SomeFunction() {
        return _react.default.createElement("div", null);
      }

      var SomeOtherFunction = function SomeOtherFunction() {
        return _react.default.createElement("div", null);
      };

      expect((0, _getDisplayName.getFunctionName)(SomeFunction)).toEqual('SomeFunction');
      expect((0, _getDisplayName.getFunctionName)(SomeOtherFunction)).toEqual('SomeOtherFunction');
    });
  });
});